#!/usr/bin/env python
# -*- coding: utf-8 -*-

# This file is a part of NoteCalc.
#
# Auteur  : Jonas Fourquier (http://jonas.tuxfamily.org)
# Licence : GNU GPL

if __name__ == "__main__":
    import notecalc


import os, gtk, pdb, gtk.glade, ConfigParser, i18n, mimetypes
import ncalc_cst    #constante
import pdb
#pdb.set_trace()

class image:

    def __init__(self, name='tmp', dico_img={}, gui=True, tmX=320, tmY=240): #name dico_img_gui X Y
        print "*** Image ***"
        self.name = str(name)
        self.tmX = tmX
        self.tmY = tmY
        self.changed = True
        self.dico_img = dico_img

        if not (dico_img == {}) :
            self.tmppath =  os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',dico_img['file_name'])
            self.path =     dico_img['original_path']
            self.size =     dico_img['print_size']
            self.pbThumb =  dico_img['pixbuf']
            if not self.pbThumb :
                self.pbThumb = self.get_pbthumb(self.tmppath)
            self.asImage =  True

            self.mtype = mimetypes.guess_type(self.tmppath)[0]
        else:
            self.tmppath = None
            self.path = None
            self.size = 1.
            self.mtype = None
            self.asImage = False


        if gui :
            import gtk.glade

            self.gui = gtk.glade.XML(os.path.join(os.environ['NOTECALC_DIR'],'gui','image.glade'))
            dictionnaire_temporaire = {}
            for iteration in dir(self.__class__):
                dictionnaire_temporaire[iteration]= getattr(self,iteration)
            self.gui.signal_autoconnect(dictionnaire_temporaire)

            #connection menu
            self.gui.get_widget('insert_img').connect_object("event", self.on_insertORedit_img_pressed, self.create_menuModel())

            if self.asImage :
                self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)
                self.gui.get_widget('name_img').set_text(dico_img['name'])


                #~ start = chaine_options.find('name:')
                #~ end = chaine_options.find("\n",start)
                #~ if (end == -1): self.gui.get_widget('name_img').set_text(chaine_options[start+5:])
                #~ else :          self.gui.get_widget('name_img').set_text(chaine_options[start+5:end])

                self.gui.get_widget('size_img').set_value(self.size*100)




            gtk.main()


    def sizeThumb(self,otmX,otmY):
        #~ size = self.gui.get_widget('size_img').get_value()
        size = self.size
        tmX = int(round(otmX*size))
        tmY = int(round(otmY*size))
        if tmX < 10 | tmY < 10 :
            '''Si l'image est trop petite (10px)'''
            if tmX < tmY:
                tmY = otmY/otmX
                tmX = 10
            else :
                tmY = 10
                tmX = otmX/otmY
        return tmX,tmY


    def on_edit_img_clicked(self,event):
        '''Editer l'image avec le programme spécifier dans edit_img.ini'''
        print '*** édition de l\'image ***\n%s'%self.tmppath
        cfEdit = ConfigParser.ConfigParser()
        cfEdit.read(os.path.join(os.environ['NOTECALC_USERDIR'],'edit_image.ini'))
        if (cfEdit.has_option('edit_image', self.mtype)) :
            '''type de fichier a une application d'édition liée, la lance'''
            os.system(cfEdit.get('edit_image', self.mtype)%self.tmppath)
            msgdialog = gtk.MessageDialog(
                            None, #parent
                            gtk.DIALOG_DESTROY_WITH_PARENT, # flag
                            gtk.MESSAGE_WARNING,            # type
                            gtk.BUTTONS_OK,                 # boutons
                            _('Valider une fois l\'édition et l\'enregistrement de l\'image réalisé.') # Message
                        )
            msgdialog.run()
            msgdialog.destroy()

            # maj de l image
            (tmX, tmY) = self.sizeThumb(self.tmX, self.tmY)
            self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.tmppath, tmX, tmY)
            self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)
        else :
            msgdialog = gtk.MessageDialog(
                            None, #parent
                            gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                            gtk.MESSAGE_WARNING,            # type
                            gtk.BUTTONS_OK,                 # boutons
                            _('Les images de type "%(mimetype)s" ne sont associée à aucun logiciel.\
                                \nÉditer le fichier de configuration "%(pathconfig)" pour en associer un.'\
                                %{'mimetype':self.mtype, 'pathconfig': os.path.join(os.environ['NOTECALC_USERDIR'],'edit_image.ini')}) #Message
                        )
            msgdialog.run()
            msgdialog.destroy()



    def on_valid_img_clicked(self,event):
        '''validation de l'image'''
        self.as_changed = True
        self.name = self.gui.get_widget('name_img').get_text()
        self.size = self.gui.get_widget('size_img').get_value()/100
        self.gui.get_widget('win_img').destroy()
        gtk.main_quit()

    def on_cancel_img_clicked(self,event):
        self.gui.get_widget('win_img').destroy()
        self.as_changed = False
        gtk.main_quit()

    def on_win_img_destroy(self,event=None):
        print '''fermeture image'''
        gtk.main_quit()

    def on_del_img_clicked(self,event):
        image = self.gui.get_widget('img_view')
        image.set_from_stock('gtk-missing-image',gtk.ICON_SIZE_DIALOG)

    def on_insertORedit_img_pressed(self,widget,event):
        '''Création du menu à partir du fichier ini'''
        if event.type == gtk.gdk.BUTTON_PRESS:
            widget.popup(None, None, None, event.button, event.time)
            # On fait savoir au code appelant que l'on a traite l'evenement. Son
            # histoire s'arrete ici.
            return True
        # On fait savoir au code appelant que l'evenement n'a pas ete traite. Il continue.
        return False


    def on_size_img_button_release_event(self,widget,event):
        '''quand on relache le bouton, redimm de l'image'''
        print 'redim img'
        self.size = self.gui.get_widget('size_img').get_value()/100
        (tmX, tmY) = self.sizeThumb(self.tmX, self.tmY)
        print self.tmppath
        self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.tmppath, tmX, tmY)
        self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)



    def create_menuModel(self):
        '''Création du menu chargement model'''
        menu = gtk.Menu()
        commandes = gtk.MenuItem(_("Fichier"))
        menu.append(commandes)
        commandes.connect("activate", self.on_insertmenu_activate, "file")
        commandes.show()

        for modelFile in os.listdir(os.path.join(os.environ['NOTECALC_DIR'],'model_images')) :
            if os.path.isfile(os.path.join(os.environ['NOTECALC_DIR'],'model_images',modelFile)):
                commandes = gtk.MenuItem(modelFile)
                menu.append(commandes)
                commandes.connect("activate", self.on_load_model_activate, modelFile)
                commandes.show()

        commandes = gtk.MenuItem(modelFile)
        menu.append(commandes)
        commandes.connect("activate", self.on_delete_image_activate, "unlink")
        commandes.show()

        return menu


    def on_delete_image_activate(self, widget, pouet):
        '''Supression de l'image'''
        pass

    def on_load_model_activate(self, widget, modelFile):
        '''Chargement d'un fichier model'''
        from shutil import copyfile

        self.path = os.path.join(os.environ['NOTECALC_DIR'],'model_images',modelFile)
        print "chargement de %s"%self.path
        #~ (tmX,tmY) = (self.tmX,self.tmY)
        try :
            self.mtype = mimetypes.guess_type(self.path)[0]
            ext = mimetypes.guess_extension(self.mtype)
            (tmX, tmY) = self.sizeThumb(self.tmX, self.tmY)
            self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.path, tmX, tmY)
            self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)
            from shutil import copyfile
            self.tmppath = os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',''.join((self.name,ext)))
            copyfile (self.path,self.tmppath)
        except :
            msgdialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING,            # type
                    gtk.BUTTONS_OK,                 # boutons
                    _('Format non reconnu')         #Message
                )
            msgdialog.run()
            msgdialog.destroy()
        finally :
            self.asImage = True





    def on_insertmenu_activate(self, widget, action):
        '''Acion lors de la séléction du type d'insertion
          * Action est une chaine'''
        #~ pdb.set_trace()

        if action == "file":
            '''Ouvre l'explorateur de fichier'''
            wParent = None
            chooser = gtk.FileChooserDialog(_("Ouvrir une image ..."),
                                            wParent,
                                            gtk.FILE_CHOOSER_ACTION_SAVE,
                                            (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                            gtk.STOCK_SAVE, gtk.RESPONSE_OK));

            if self.name:
                chooser.set_current_folder(self.name)
            else:
                chooser.set_current_folder(os.environ['HOME'])

            filtre = gtk.FileFilter()
            filtre.set_name(_("Toutes les images"))
            filtre.add_mime_type("image/jpeg")
            filtre.add_mime_type("image/png")
            filtre.add_mime_type("image/gif")
            filtre.add_mime_type("image/tiff")
            filtre.add_mime_type("image/x-cmu-raster")
            filtre.add_mime_type("image/x-portable-anymap")
            filtre.add_mime_type("image/x-portable-bitmap")
            filtre.add_mime_type("image/x-portable-graymap")
            filtre.add_mime_type("image/x-portable-pixmap")
            filtre.add_mime_type("image/x-rgb")
            filtre.add_mime_type("image/x-xbitmap")
            filtre.add_mime_type("image/x-xpixmap")
            filtre.add_mime_type("image/x-xwindowdump")
            filtre.add_mime_type("image/svg+xml")
            chooser.add_filter(filtre)
            del filtre

            filtre = gtk.FileFilter()
            filtre.set_name(_("Image JPEG"))
            filtre.add_mime_type("image/jpeg")
            chooser.add_filter(filtre)
            del filtre

            filtre = gtk.FileFilter()
            filtre.set_name(_("Image PNG"))
            filtre.add_mime_type("image/png")
            chooser.add_filter(filtre)
            del filtre

            filtre = gtk.FileFilter()
            filtre.set_name(_("Image GIF"))
            filtre.add_mime_type("image/gif")
            chooser.add_filter(filtre)
            del filtre

            filtre = gtk.FileFilter()
            filtre.set_name(_("Image SVG"))
            filtre.add_mime_type("image/svg+xml")
            chooser.add_filter(filtre)
            del filtre

            filtre = gtk.FileFilter()
            filtre.set_name(_("Tous les fichiers"))
            filtre.add_pattern("*")
            chooser.add_filter(filtre)
            del filtre


            # previews
            #~ self.preview = gtk.Image()
            #~ self.set_preview_widget (self.preview)
            #~ self.connect ("update-preview", self.update_preview_cb)

            if (chooser.run() == gtk.RESPONSE_OK):
                import mimetypes
                from shutil import copyfile

                self.path = chooser.get_filename()
                (tmX, tmY) = self.sizeThumb(self.tmX, self.tmY)
                try :
                    self.mtype = mimetypes.guess_type(self.path)[0]
                    ext = mimetypes.guess_extension(self.mtype)
                    self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.path, tmX, tmY)
                    self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)
                    from shutil import copyfile
                    self.tmppath = os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',''.join((self.name,ext)))
                    copyfile (chooser.get_filename(),self.tmppath)
                except :
                    msgdialog = gtk.MessageDialog(
                            None, #parent
                            gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                            gtk.MESSAGE_WARNING,            # type
                            gtk.BUTTONS_OK,                 # boutons
                            _('Format non reconnu')         #Message
                        )
                    msgdialog.run()
                    msgdialog.destroy()


            chooser.destroy()
        #~ else :
            #~ tmppath = os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),self.name)
            #~ os.system(action%tmppath)
#~
            #~ msgdialog = gtk.MessageDialog(
                            #~ None, #parent
                            #~ gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                            #~ gtk.MESSAGE_WARNING,            # type
                            #~ gtk.BUTTONS_OK,          # boutons
                            #~ _('Valider une fois l\'édition et l\'enregistrement de l\'image réalisé') #Message
                        #~ )
            #~ msgdialog.run()
            #~ msgdialog.destroy()
#~
            #~ self.path = ''
#~
            #~ size = self.gui.get_widget('size_img').get_value()
            #~ self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.tmppath, self.tmX*size/100, self.tmY*size/100)
            #~ self.gui.get_widget('img_view').set_from_pixbuf(self.pbThumb)






    def get_pbthumb(self,path=False, size=False):
        '''Charge une image à partir d'un fichier et de la taille, retourne un pixbuf'''
        if path : self.tmppath = path
        if size : self.size = size
        print '*** get_pbthumb ***\n file %s - size %s'%(self.path,self.size)
        import mimetypes
        from shutil import copyfile

        if not os.path.exists(self.tmppath):
            pdb.set_trace()

            msgdialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, # flag
                    gtk.MESSAGE_WARNING,            # type
                    gtk.BUTTONS_OK,                 # boutons
                    _('L\'image %(file)s n\'a pas été trouvée. Veuillez charger une autre image.')\
                        %{'file': self.file}        #Message
                )
            msgdialog.run()
            msgdialog.destroy()
            return None

        #~ try :
        (tmX, tmY) = self.sizeThumb(self.tmX, self.tmY)
        #~ self.mtype = mimetypes.guess_type(self.path)[0]
        #~ ext = mimetypes.guess_extension(self.mtype)
        self.pbThumb = gtk.gdk.pixbuf_new_from_file_at_size(self.tmppath, tmX, tmY)
            #~ self.tmppath = os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',''.join((self.name,ext)))
            #~ copyfile (self.path,self.tmppath)
        #~ except :
            #~ msgdialog = gtk.MessageDialog(
                    #~ None, #parent
                    #~ gtk.DIALOG_DESTROY_WITH_PARENT, # flag
                    #~ gtk.MESSAGE_WARNING,            # type
                    #~ gtk.BUTTONS_OK,                 # boutons
                    #~ _('Format d\'image non reconnu.')         #Message
                #~ )
            #~ msgdialog.run()
            #~ msgdialog.destroy()
            #~ return None

        return self.pbThumb

    #initialisation variable
    def set_name(self, name=None):
        '''Initialise le nom de l'image et sont chemain
            * Si elle existe déjà retourn True
            * Si elle n'existe pas retourn False'''
        self.oldname = name
        self.name = name

        if name :
            self.tmpimg = os.path.join(os.environ['NOTECALC_USERDIR'],'img',name)
            if os.files_exists(self.path_img) :
                '''affiche l'image si elle existe'''
                self.gui.get_widget('img_view').set_from_file(path_img)
                return True
            else :
                self.path_img = None
                return False
        else :
            self.path_img = None
            return False

    def get_str4render(self):
        '''retourne la chaine de rendu au format text'''
        if self.name == '' :
            '''Pas de nom d'image, on affiche le chemin'''
            if (len(self.path) > 16):
                '''rogne le début de chemain car trop long'''
                imgname = ''.join(('...',self.path[-13:]))
            else :
                imgname = self.path
        else :
            imgname = self.name
        _('[Figure : %(name)s (%(size)s%%)]'%{'name':imgname,'size':(self.size*100)})

    def get_dicoimg(self):
        '''retourne le dico a mettre dans "affichage"'''
        return {
                'name':         self.name,
                'file_name' :   os.path.basename(self.tmppath),
                'original_path':self.path,
                'print_size':   self.size,
                'pixbuf':       self.pbThumb
            }






def main():
    gtk.main()


if __name__ == "__main__":
    imgwin = image()
    #~ imgwin.window()
    #~ main()


