﻿#!/usr/bin/env python

#Plugin LaTeX pour notecalc

# Distribué selon les termes de le GNU GPL v3

#import gtk
import os,gtk,ncalc_cst,ConfigParser,gobject
import pdb
#~ pdb.set_trace()

class pluginLaTeX:
    '''Créer un fichier latex'''

    def __init__(self):
        fileconfig = os.path.join(os.environ['NOTECALC_CONFPLUGINSDIR'],'export_latex.cfg')
        if not os.path.exists(fileconfig) :
            dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING, # type
                    gtk.BUTTONS_OK, # boutons
                    _("Veuillez d'abord configurer le plugin \"export_LaTeX\".")#Message
                )
            dialog.run()
            dialog.destroy()
            options()
        self.config = ConfigParser.ConfigParser()
        self.config.read(fileconfig)

        self.stats = {
                'label':'',
                'progress':0,
                'hidden':True
            }

        #~ if not self.file :


        #~ self.progressBox = gtk.Dialog(
                    #~ title="Export LaTeX", parent=None, flags=0, buttons=None
                #~ )
        #~ self.progressBarre = gtk.ProgressBar()
        #~ self.progressBox.action_area.pack_start(self.progressBarre, True, True, 0)
        #~ self.progressBarre.show()
        #~ self.progressBox.show()




    def chooser(self,file) :

        import gtk

        wFileSelection = gtk.FileChooserDialog("Exporter en LaTeX ...",
                                               None,
                                               gtk.FILE_CHOOSER_ACTION_SAVE,
                                               (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
                                               gtk.STOCK_OK, gtk.RESPONSE_OK))
        if file :
            wFileSelection.set_current_folder(file)
        else :
            wFileSelection.set_current_folder(os.path.expanduser('~'))


        if (wFileSelection.run() == gtk.RESPONSE_OK):
            print '***creationTEX : %s****' %wFileSelection.get_filename()
            filechoose = wFileSelection.get_filename()
            wFileSelection.destroy()
            return filechoose
        else :
            wFileSelection.destroy()
            return False



    def createLaTeX(self,file,info,list):
        from time import strftime

        #~ progressBox = gtk.Window(gtk.WINDOW_TOPLEVEL)
        #~ progressBox.set_title("Création des sources LaTeX")
        #~ progressBarre = gtk.ProgressBar()
        #~ progressBarre.show()
        #~ progressBox.add(progressBarre)
        #~ progressBox.show()

        self.stats = {
                'label':'Création des sources LaTeX',
                'progress':0,
                'hidden':False
            }

        nb_partProgressBar = len(list) + 2
        partProgressBar = 1
        self.stats['progress'] = partProgressBar/nb_partProgressBar

        if file[-4:].lower() == '.tex':
            fileTEX = file
        else:
            fileTEX = '.'.join((file,'tex'))

        dirPictures = '_'.join((fileTEX[0:-4],'pictures'))

        #Charger configuration
        docclass = [
                self.config.get('Option exportLaTeX', 'format'),
                '%spt'%(self.config.get('Option exportLaTeX', 'policeSize')),
                self.config.get('Option exportLaTeX', 'lang')
            ]
        if self.config.getint('Option exportLaTeX', 'twocolum'):
            docclass.append('twocolum')
        if self.config.getint('Option exportLaTeX', 'twoside'):
            docclass.append('twoside')
        else:
            docclass.append('oneside')
        if self.config.getint('Option exportLaTeX', 'landscape'):
            docclass.append('landscape')
        if self.config.getint('Option exportLaTeX', 'titlepage'):
            docclass.append('titlepage')
        else :
            docclass.append('notitlepage')
        #~ docClass = self.config.getfile('Option exportLaTeX', 'documentclass')




        file = open(fileTEX,'w')

        # Pour les file write ne pas oublier de protéger les \ (→ \\)

        file.write("\\documentclass[" + ','.join(docclass) + "]{article}\n\n")

        file.write("""
            \\usepackage[utf8]{inputenc}
            \\usepackage[francais]{babel}
            \\usepackage{amsmath}
            \\usepackage{amsfonts}
            \\usepackage{amssymb}
            \\usepackage{tabularx}
            \\usepackage{graphicx}

            %macro tableau de calcul avec commentaire
            \\def\\arraycalcwithcomment{%
                \\tabularx{\\linewidth}{XXr} % calculs resultat commentaire no
            }

            \\def\\endarraycalcwithcomment{
                \\endtabularx
            }
            %end macro

            %macro tableau de calcul sans commentaire
            \\def\\arraycalc{%
                \\tabularx{\\linewidth}{Xr} % calculs resultat commentaire no
            }

            \\def\\endarraycalc{
                \\endtabularx
            }
            %end macro

            \\begin{document}""")


        #Entête
        file.write("\\title{%s}\n"%info['title'])
        file.write("\\author{%s}\n"%info['author'])
        file.write("\\date{%s}\n"%strftime('%x',info['date']))
        file.write("\\maketitle\n\n")

        #Table de matière
        file.write("\\tableofcontents\n")



        for item in list:
            partProgressBar += 1
            self.stats['progress'] = partProgressBar/nb_partProgressBar
            if item['type'] == 'img':
                '''images'''
                #convertir l'image
                import Image,mimetypes
                #crer le dossier qui contiendera les images
                if not os.path.exists(dirPictures) :
                    os.mkdir(dirPictures)
                print "convertion de l'image %s en eps"%(os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',item['aff']['file_name']))

                #conversion des image
                im_source = os.path.join(os.environ['NOTECALC_USERDIR'],ncalc_cst.get_currentdir(),'pictures',item['aff']['file_name'])
                #~ pdb.set_trace()
                if mimetypes.guess_type(im_source)[0] == "image/svg+xml" :
                    '''Pour les svg'''
                    # pourait etre améliorer en faissant une conversion direct svg → eps
                    tmpfile = os.path.join(dirPictures,'tmp.png')
                    pf = gtk.gdk.pixbuf_new_from_file_at_size(im_source,1024,1024)
                    pf.save(tmpfile,'png')
                    del pf
                    im = Image.open(tmpfile)
                    if im.mode == 'RGBA' :
                        (x,y) = im.size
                        imRGB = Image.new('RGB',(x,y),'#FFFFFF') #fond blanc
                        imRGB.paste(im,(0,0,x,y),im) #comme l'image sur le fond blanc
                        imRGB.save(os.path.join(dirPictures,'%s.eps'%item['id']))
                        del imRGB
                    else :
                        im.save(os.path.join(dirPictures,'%s.eps'%item['id']))
                    del im
                    os.unlink(tmpfile)
                else :
                    '''Autre type d'image'''
                    im = Image.open(im_source)
                    if im.mode == 'RGBA' :
                        r,g,b,a = im.split()
                        im = Image.merge("RGB", (r,g,b))
                        del r,g,b,a
                    im.save(os.path.join(dirPictures,'%s.eps'%item['id']))
                    del im

                if item['comment'] != '':
                    legend = ', '.join((item['aff']['name'],item['comment']))
                else:
                    legend = item['comment']

                file.write("""\n
                    \\begin{figure}
                        \\center
                        \\includegraphics[width=%s\\textwidth]{%s}\n
                        \\caption{%s}
                    \\end{figure}
                    """ %(item['aff']['print_size'],os.path.join(dirPictures,'%s.eps'%item['id']),legend))

            else :
                item['render'] = self.pengo2latex(item['render'])

                if item['type'][0] == 'h':
                    '''titre'''

                    render = item['render'].split('\\newline',1)

                    titre = render[0]
                    if len(render) == 2 :
                        soustitre = '\n'.join((render[1],item['comment']))
                    else :
                        soustitre = item['comment']


                    if item['type'] == 'h1':
                        file.write("""\n
                            \\section{%s}\n
                            %s""" %(titre, soustitre))
                    elif item['type'] == 'h2':
                        file.write("""\n
                            \\subsection{%s}\n
                            %s""" %(titre, soustitre))
                    elif item['type'] == 'h3':
                        file.write("""\n
                            \\subsubsection{%s}\n
                            %s""" %(titre, soustitre))
                    elif item['type'] == 'h4':
                        file.write("""\n
                            \\paragraph{%s}\n
                            %s""" %(titre, soustitre))
                    elif item['type'] == 'h5':
                        file.write("""\n
                            \\subparagraph{%s}\n
                            %s""" %(titre, soustitre))
                    else :
                        file.write("""\n
                            \\\bfseries{%s}\n
                            %s""" %(titre, soustitre))

                elif item['type'] == 'txt' :
                    '''texte tout bête'''
                    file.write("""\n
                        %(render)s\n
                        %(comment)s""" %item)

                else :
                    '''La ligne un resultat, c'est donc un calcul'''
                    item['render'] = item['render'].replace('*','\\cdot')
                    if item['unit'] :
                        item['unit'] = "[\\begin{textit}%s\\end{textit}]"%self.pengo2latex(item['unit'])
                    item['unit'] = item['unit'].replace('*','\\cdot')
                    if item['comment'] :
                        file.write("""\n
                            \\begin{arraycalcwithcomment}
                                $ %(render)s = %(resultat)s %(unit)s $ & \\textit{%(comment)s} & (\\$%(id)s) \\\\
                            \\end{arraycalcwithcomment}""" %item)
                    else :
                        file.write("""\n
                            \\begin{arraycalc}
                                $ %(render)s = %(resultat)s %(unit)s $ & (\\$%(id)s) \\\\
                            \\end{arraycalc}""" %item)

        self.stats['progress'] = 1
        file.write("\n\\end{document}")
        file.close()

        return fileTEX

    def compilLaTeX(self,fileTEX) :
        '''compile avec les outils du systeme le fichier'''
        self.stats['label'] = 'Compilation ...'
        self.stats['progress'] = 'pulse'
        (path,file) = os.path.split(fileTEX)
        (name,ext) = os.path.splitext(file)
        fileAUX = os.path.join(path,"%s.aux"%name)
        fileDVI = os.path.join(path,"%s.dvi"%name)
        os.chdir(path)

        try :
            '''si un ancien aux existe, calcul sa somme md5'''
            fpAUX = open(fileAUX,'r')
            contentAUXold = fpAUX.read()
            fpAUX.close()
            #et on efface le dvi
            os.unlink(fileDVI)
        except :
            contentAUXold = ''

        try :
            cmdsys = ' '.join((self.config.get('Option exportLaTeX', 'compilator'),'-halt-on-error','"%s"'%fileTEX))
            logcmdsys = os.system('"%s"'%cmdsys)
        except :
            dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_ERROR, # type
                    gtk.BUTTONS_OK, # boutons
                    "Erreur lors de la compliation LaTeX"#Message
                )
            dialog.run()

        #~ pdb.set_trace()
        if os.path.exists(fileDVI) :
            fpAUX = open(fileAUX,'r')
            contentAUX = fpAUX.read()
            fpAUX.close()
        else :
            #~ pdb.set_trace()
            print 'Erreur : aucun fichier ".dvi" trouvé compilateur LaTeX ok ?\n (Commande executée : %s)'%cmdsys
            dialog = gtk.MessageDialog(
                    None, #parent
                    gtk.DIALOG_DESTROY_WITH_PARENT, #flag
                    gtk.MESSAGE_WARNING, # type
                    gtk.BUTTONS_OK, # boutons
                    "Aucun fichier dvi n'a été créer. Il y a certainement eu un problème lors de la compilation.\n\nConsulter le fichier de log (%s) pour en savoir plus."%os.path.join(path,'%s.log'%name)#Message
                )
                    #~ _("Le fichier \"aux\" n'a pas été trouvé, vérifiez le compilateur dans la configuration du plugin \"export_LaTeX\"."))#Message

            dialog.run()
            dialog.destroy()
            contentAUX = ''
            #~ pdb.set_trace()


        nd_essai = 0
        while (contentAUXold != contentAUX) :
            '''tant que la md5sum du fichier aux après compilation varie c'est
            que la table de matière risque d'être incorrecte.'''
            if nd_essai >100 :
                print "error nb essai de compil > 100"
                break
            nd_essai += 1
            os.system('"%s"'%cmdsys)
            contentAUXold = contentAUX
            fpAUX = open(fileAUX,'r')
            contentAUX = fpAUX.read()
            fpAUX.close()
            #~ pdb.set_trace()

        self.stats['label'] = 'Terminer !'
        self.stats['progress'] = 1

        return fileDVI



    def pengo2latex(self,s):
        import re

        s = s.replace('<sub>','_{')         #indice
        s = s.replace('</sub>','}')
        s = s.replace('<sup>','\\begin{up}')         #exposant
        s = s.replace('</sup>','\\end{up}')
        s = s.replace('³','^{3}')
        s = s.replace('²','^{2}')
        s = s.replace('<i>','\\begin{textit}')    #itallique
        s = s.replace('</i>','\\end{textit}')
        s = s.replace('\n',' \\newline ')   #nouvelle ligne

        s = re.sub('<([\S][^<]*)>','',s) #supprimer les balises pengo
        return s



# Fonction oblicatoire pour tout les plugins, c'est celle qui est lancer lors
# du click sur ok de la boite de selection des plugins


def run(dicoInfo,listCalc,file=None):
    '''Fonction lancée lor de l'execution du plugin'''
    file = plug.chooser(file)
    fileTEX = plug.createLaTeX(file,dicoInfo,listCalc)
    if plug.config.get('Option exportLaTeX', 'compilator') != '':
        plug.compilLaTeX(fileTEX)

def options():
    #~ print os.getcwd()
    from imp import load_source
    prefs = load_source('main',os.path.join(os.environ['NOTECALC_DIR'],"plugins",'export_LaTeX','preferences.py'))

def get_stats():
    return plug.stats


plug = pluginLaTeX()

# Si lancement direct : petits dicos bindons pour test
if __name__ == '__main__':
    '''Pour les tester : dicos bidons'''
    from time import strftime

    dicoInfo = {
        'title': 'Titre',
        'description': 'blabla',
        'author': 'JF',
        'date' : strftime('%d/%m/%Y %H:%M')
        }
    listCalc = [
            {'comment': '', 'render': '<span size="xx-large" style="italic" weight="bold"> Un petit Test</span>\nBen oui koi', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '! Un petit Test\nBen oui koi', 'type': 'h1', 'id': 1, 'unit': ''},
            {'comment': '', 'render': '<span size="xx-large" style="italic">image</span>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '!!image', 'type': 'h2', 'id': 2, 'unit': ''},
            {'comment': '3', 'render': None, 'linkcalc': [], 'aff': {'original_path': u'/home/jonas/Developpement/Python/notecalc/src/model_images/Poutre.svg', 'file_name': u'3.svg', 'pixbuf': None, 'name': '3', 'print_size': 1.0}, 'listVar': {}, 'precision': 0, 'nameVar': '', 'resultat': 0.0, 'entry': 'img', 'type': 'img', 'id': 3, 'unit': ''},
            {'comment': '', 'render': '<span size="xx-large" style="italic">variable</span>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '!!variable', 'type': 'h2', 'id': 4, 'unit': ''},
            {'comment': '', 'render': 'a = 2', 'linkcalc': [7], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': 'a', 'resultat': 2.0, 'entry': 'a = 2', 'type': 'calcvar', 'id': 5, 'unit': ''},
            {'comment': '', 'render': 'b = 6', 'linkcalc': [7], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': 'b', 'resultat': 6.0, 'entry': 'b = 6', 'type': 'calcvar', 'id': 6, 'unit': ''},
            {'comment': '', 'render': 'a+b/3\n5+6/3', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {u'a': 5, u'b': 6}, 'precision': 2, 'nameVar': '', 'resultat': 7.0, 'entry': 'a+b/3', 'type': 'calc', 'id': 7, 'unit': ''},
            {'comment': '', 'render': '<span size="xx-large" style="italic">unti\xc3\xa9e</span>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '!!unti\xc3\xa9e', 'type': 'h2', 'id': 8, 'unit': ''},
            {'comment': '', 'render': '2+2', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 4.0, 'entry': '2+2=[kN]', 'type': 'calc', 'id': 9, 'unit': 'kN'},
            {'comment': '', 'render': '<span size="xx-large" style="italic">blabla</span>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '!!blabla', 'type': 'h2', 'id': 10, 'unit': ''},
            {'comment': '', 'render': '<i>blabbla</i>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '/*blabbla*/', 'type': 'calc', 'id': 11, 'unit': ''},
            {'comment': '', 'render': '<span size="xx-large" style="italic">Multiligne</span>', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 0.0, 'entry': '!!Multiligne', 'type': 'h2', 'id': 12, 'unit': ''},
            {'comment': '', 'render': '3*2 \n+4*5 \n+2*3 ', 'linkcalc': [], 'aff': (True, True, False), 'listVar': {}, 'precision': 2, 'nameVar': '', 'resultat': 32.0, 'entry': '3*2 //Chambre\n+4*5 //Grand salon\n+2*3 //Cuisine\n= [m\xc2\xb2] //total rez', 'type': 'calc', 'id': 13, 'unit': '[m\xc2\xb2]'}
        ]
    #~ options()
    run(dicoInfo,listCalc)
    gtk.main()
